;-------------------------------------------------------------------------------
; MyCom2.dll        copyright 7/15/00 Ernest J Murphy
;
;  sample project to illustrate how to use CoLib, a Component Object Library 
;
;-------------------------------------------------------------------------------

.NOLIST  ; keep the list file small, don't add the std libs to it.
.486
.model flat, stdcall
option casemap:none ; case sensitive

;LINK : fatal error LNK1000: unknown error; consult documentation for technical support options
;changer d'envirronnement debug release
;-------------------------------------------------------------------------------
include     \masm32\include\windows.inc
include     \masm32\include\user32.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\advapi32.inc    
include     \masm32\include\oleaut32.inc
;include     \masm32\include\masm32.inc
include     \masm32\include\ole32.inc
include \masm32\include\shlwapi.inc

include     \sdkrc7\translate.inc ;oaidl.inc  
 ; basic COM definitions
include    colib.inc  
 ; the new library

include     IMyCom2.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\advapi32.lib
includelib  \masm32\lib\oleaut32.lib
includelib  \masm32\lib\ole32.lib
includelib  \masm32\lib\masm32.lib
includelib  colib.lib ; ------- the new library ---------
includelib \masm32\lib\shlwapi.lib

AutoRegister PROTO 
AutoUnRegister PROTO 
PUBLIC Liste_CLSID

;-------------------------------------------------------------------------------
.data
bonjour db "Hello from the server",0
titre db "Have a look on mycom2.asm to view lists organisation",0
;----------------- Implemention of IMyCom2 -------------------------
;masm limitation on number of proc,use dd instead of struct <>
IMyCom2_Vtbl  	dd Colib_QueryInterface
			dd Colib_AddRef
			dd Colib_Release
	;---------- end IUnknown ----------------			
			;dd GetTypeInfoCount
			;dd GetTypeInfo
			;dd GetIDsOfNames
			;dd Invoke_
	;---------- end IDispatch ---------------
			dd Colib_Release			;GetTypeInfoCount are not been rewrite
			dd Colib_Release              ;just a trick to avoid used of them
			dd Colib_Release
			dd Colib_Release
			;--------------------------------									
			dd GetValue
			dd SetValue
			dd RaiseValue			
interface_IMyCom2	IMyCom2_Interface	<IMyCom2_Vtbl,sizeof interface_IMyCom2,offset Liste_IID_MyCom2,,>

;------------- lists of what is here for the DllGetClassObject fonction --------
;----------------- called by CoCreateInstance and others functions -------------
;----- list(s) for interface , first is adress of This structure
Liste_IID_MyCom2 dd interface_IMyCom2
IID_IMyCom2 GUID sIID_IMyCom2
	    ;for each clsid we do a list of supported interfaces
dd 0      ;end of this interface list
;end of the list of interfaces
;------- other interfaces list for different clsid here ----------

;none

;---------------- end of interface list ------------------------------------------
;-------------- The only one who is exported , the adress of the list of CLSID --------
Liste_CLSID dd offset Debut_liste_CLSID
Debut_liste_CLSID dd offset Liste_IID_MyCom2 ; For each CLSID,the adress of list interfaces @@@@
;--------------------------------------------------------------------------------------		;adress of the list of interfaces supported by the CLSID
CLSID_MyCom2 GUID sCLSID_MyCom2	;declaration of the CLSID
dd 0            ;end of list of clsid


;-------------------------------------------------------------------------------
.code
;-------------------------------------------------------------------------------
GetValue PROC this_:DWORD, pval:DWORD   ; GetValue for the IMyCom Interface
	
	invoke MessageBox,NULL,ADDR bonjour,addr titre,MB_OK

    xor eax, eax                                ; return S_OK
    ret
GetValue ENDP

;-------------------------------------------------------------------------------
SetValue PROC this_:DWORD, val:DWORD    ; SetValue for the IMyCom Interface
    xor eax, eax                                ; return S_OK
    ret
SetValue ENDP

;-------------------------------------------------------------------------------
RaiseValue  PROC this_:DWORD, val:DWORD ; RaiseValue for the IMyCom Interface
    xor eax, eax                                ; return S_OK
    ret
RaiseValue ENDP

;-------------------------------------------------------------------------------



DllMain PROC PUBLIC hModule:HANDLE, dwReason:DWORD, pReserved:DWORD
	invoke EntryDllMain, hModule, dwReason,pReserved
ret
DllMain endp


end DllMain
