;-------------------------------------------------------------------------------
;  colibrary procedure DllMain
;
; -------------------------------------------------------
; This procedure was written by Ernest Murphy    9/27/00
;
; Copyright (c) 9/28/00  Ernest Murphy
; For educational use only. Any commercial re-use only by written license
;
; -------------------------------------------------------
.NOLIST
.486
.model flat, stdcall  ; 32 bit memory model
option casemap :none  ; case sensitive
include mini_win.inc
include     \masm32\include\oleaut32.inc
include     \masm32\include\ole32.inc
include     \masm32\include\kernel32.inc
include     \masm32\macros\macros.asm

include     colib.inc

externdef   g_hModule:DWORD       
externdef   g_hHeap:DWORD       
externdef   g_ObjectCount:DWORD       


PUBLIC g_hModule    

.data

g_hModule               DWORD           0
g_hHeap                 DWORD           0


.code
;-------------------------------------------------------------------------------

EntryDllMain PROC PUBLIC hModule:HANDLE, dwReason:DWORD, pReserved:DWORD

             
;-------------------------------------------------------------------------------
; COM server dll main export
;   The EntryDllMain function is the method of entry into COM server
;    dynamic-link library 
;   
;-------------------------------------------------------------------------------
    .IF dwReason == DLL_PROCESS_ATTACH
        mov eax, hModule
        mov g_hModule, eax
        ; get handle for global heap
        invoke GetProcessHeap
        mov g_hHeap, eax
        mov eax, TRUE
    .ELSEIF dwReason == DLL_PROCESS_DETACH
        mov eax, TRUE
    .ELSE
        xor eax, eax        ; mov eax, FALSE
    .ENDIF
    ret
EntryDllMain Endp
;-------------------------------------------------------------------------------

DllCanUnloadNow PROC PUBLIC
             
;-------------------------------------------------------------------------------
; COM server dll main export
;   Determines whether the DLL that implements this function is in use. 
;   If not, the caller can safely unload the DLL from memory.
;   
;
; EXAMPLE:
;   invoke DllGetClassObject, ADDR clsid, ADDR iid:DWORD, ADDR pv
;
; Uses: eax, ecx, edx
;
;
;-------------------------------------------------------------------------------
    .IF g_ObjectCount
        mov eax, S_FALSE
    .ELSEIF
        xor eax, eax            ; mov eax, S_OK
    .ENDIF
    ret
DllCanUnloadNow ENDP
;-------------------------------------------------------------------------------

DllRegisterServer PROC PUBLIC
             
    ; write the registry with the content of the reg file
    ;-----------------------------------------------
	invoke Write_Regedit_File,100,chr$("REGISTRY")
	push eax
	invoke Register_Typelib
	pop edx	
        or eax,edx 
    ret
DllRegisterServer ENDP
;-------------------------------------------------------------------------------

DllUnregisterServer PROC PUBLIC
	invoke UnRegister_TypeLib
	push eax
	invoke UnWrite_Regedit_File,100,chr$("REGISTRY")
	pop edx
        or eax,edx
FindeDllUnregisterServer:     
    ret
DllUnregisterServer ENDP
;-------------------------------------------------------------------------------




;------------- ajout ---------------------------
;################################################################
AutoRegister PROC 
	invoke DllRegisterServer
         ret
AutoRegister endp

;################################################################

;################################################################
AutoUnRegister PROC 
	invoke DllUnregisterServer
         ret
AutoUnRegister endp

;################################################################



end
